#include <stdio.h>
#include <sys/types.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define MAX_INPUT_SIZE 1024
#define MAX_TOKEN_SIZE 64
#define MAX_NUM_TOKENS 64

/* Customize your prompt by changing the value within the quotes */
/* NOTE: Double quotes are important !! */
#define MY_PROMPT "myShell> "


/*
 * tokenize() takes a pointer to a char array (or a "line" in simple words) as input and
 * splits the input on spaces, newlines and tab characters. It returns an array of char
 * arrays or putting it simply, a "list of words". Deallocation after use is left to the
 * calling routine. 
 */ 
char **tokenize(char *line)
{
    char **tokens = (char **)malloc(MAX_NUM_TOKENS * sizeof(char *));
    char *token = (char *)malloc(MAX_TOKEN_SIZE * sizeof(char));
    int i, tokenIndex = 0, tokenNo = 0;

    for(i = 0; i < strlen(line); i++) {

        char readChar = line[i];

        if (readChar == ' ' || readChar == '\n' || readChar == '\t') {
            token[tokenIndex] = '\0';
            if (tokenIndex != 0){
                tokens[tokenNo] = (char*)malloc(MAX_TOKEN_SIZE*sizeof(char));
                strcpy(tokens[tokenNo++], token);
                tokenIndex = 0; 
            }
        }

        else
            token[tokenIndex++] = readChar;
    }
 
    free(token);
    tokens[tokenNo] = NULL ;
    return tokens;
}



int main(void)
{
    char  line[MAX_INPUT_SIZE];            
    char  **tokens;              
    int i;

    while (1) {           
       
        printf(MY_PROMPT);
        bzero(line, MAX_INPUT_SIZE);
        gets(line);
        
        /* Uncomment the following line to check your input */
        /* printf("Got command %s\n", line); */
        
        line[strlen(line)] = '\n';
        tokens = tokenize(line);

        /*
        * ========================================================================+
        * Write your code to work on the list of tokens here (Delete this entire
        * comment)
        * 
        * PRO-TIP: Try to split your code into separate functions (or even across
        * different source files) based on the  task in hand, to avoid code 
        * duplicacy and make it more readable.
        * Will be helpful especially during debugging stage.
        * ========================================================================+
        */ 

        /* Uncomment the following two lines to see the list of tokens that was parsed */
        /* for(i=0;tokens[i]!=NULL;i++) */
        /*    printf("found token: %s\n", tokens[i]); */
       
        /* Free the allocated memory */
        for(i=0;tokens[i]!=NULL;i++)
            free(tokens[i]);
        free(tokens);
    }
     
    return 0;
}

                
